/* FALLET Laurent */
/* FOUILLEUX Samy */
/* MORRETTON Laurent */
/* UV SE 2003 */
/* DU + TOP */
/* Entierement compile en gcc -ansi -pedantic -Wall donc programme sans fautes, ni variables inutiles. */
#include <ncurses.h>
#include <curses.h>
#include <term.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <pwd.h>
#include <errno.h>
#include "fonction.h"

/***** DEFINE ************/
#define ENTER 10
#define ESCAPE 27
#define MAX_USERS 300
#define UID_DEPART 501
#define NON 0
#define OUI 1

/***** STRUCTURES ***********/
/* La structure du pre  */
struct informationsUtilisateurs 
{
  int ordreAlpha;
  int ordreTaille;
  int id;
  char *nom;
  char *repertoirePerso;
  int taille;
  char taille_hr[9];
};

/* La structure de mmoire partage */
struct infoPartage
{
  int uid;
  int taille;
};
/************************************/


/************** TYPEDEF *****************/
/******** Typedef du processus pre *****/
typedef struct informationsUtilisateurs InformationsUtilisateurs;
typedef InformationsUtilisateurs TableauInformationsUtilisateurs[3000];

/******** Typedef partag de transfert *****/
typedef struct infoPartage InfoPartage;
typedef InfoPartage TableauInfoPartage[MAX_USERS];
/************************************************/


/******** PROTOTYPES *****************/
void recupererUtilisateurs(int*,TableauInformationsUtilisateurs*);
void recupererTaille(int,TableauInfoPartage*,TableauInformationsUtilisateurs);
void do_key(char,int*,int*,int,char*,int,TableauInfoPartage*,int*,int*,int*);
void affichage(int, int, TableauInformationsUtilisateurs,char*,int,int,int,FILE*,int);
void actualiser_donnees(int,TableauInfoPartage,TableauInformationsUtilisateurs*);
void afficher_legende(void);
void afficher_aide(void);
void trier(TableauInformationsUtilisateurs*,int);
/************************************/


/************ MAIN ********************/
int main()
{
  int pid; /* no de processus (fils ou pere) */
  char touche,useless; /* gestion des options, useless est inutile (donc a ne pas supprimer) */
  fd_set in;
  struct timeval tv;
  int Sleeptime = 1;
  TableauInformationsUtilisateurs tabInfoUsers;
  int nbUsers;
  int index = 0; /* decalage de l'affichage */
  int indicateur = 0; /* affichage normal ou d'un seul utilisateur */
  int indicateur_hr = 0; /* affichage en ko (0) ou human readable (1) */
  char nomUser[16]; /* nom de l'utilisateur unique a afficher */
  int couleur; /* Pair de couleurs a l'origine */
  FILE *pfichier = NULL;
  FILE *plog = NULL;
  char *chemin = "                                                   ";
  time_t temps;
  char *date; /* la date pour le fichier log */
  int nbre_lignes_imprimer = 20;  /* Nombre de lignes a imprimer dans le fichier */

  /* Initialisation des variables pour le segment de mem partagee */
  key_t clef;
  int shmid;
  TableauInfoPartage* commun;

  /* initialisation de la fenetre et de ncurses */
  char titre[]="LE FABULEUX DU + TOP";
  initscr();
  start_color();
  init_pair(1,COLOR_WHITE,COLOR_BLACK);
  init_pair(2,COLOR_BLACK,COLOR_WHITE);
  init_pair(3,COLOR_WHITE,COLOR_BLUE);
  init_pair(4,COLOR_CYAN,COLOR_BLACK);
  curs_set(NON); /* ajouter ou enlever le curseur */
  couleur = 2;

  /* Recuperation des donnees */
  recupererUtilisateurs(&nbUsers, &tabInfoUsers);

  /* cration d'un fichier pour initialiser la clef */
  chemin = getenv("HOME");
  strcat(chemin,"/.dutop_log");
  plog = fopen(chemin,"a");
  if (plog == (FILE *)0)
    {
      printw("Erreur de lancement!");
    }
  temps = time(NULL);
  date = ctime(&temps);
  fprintf(plog,"%s : %s",getenv("USER"),date);
  /* Initialisation du segment de mmoire partage */
  clef = ftok(chemin,1);
  if (clef == -1)
    {
      perror("ftok");
      sleep(4);
      curs_set(OUI);
      echo();
      endwin();
      exit(EXIT_FAILURE);
    }
  shmid = shmget(clef,sizeof(TableauInfoPartage),IPC_CREAT|IPC_EXCL|0666);
  if (shmid == -1)
    {
      switch(errno)
	{
	case EEXIST :
	  fprintf(stderr,"Desole, le segment de memoire partagee existe deja!\n");
	  break;
	default:
	  perror("Erreur dans le shmget");
	  break;
	}
      sleep(4);
      curs_set(OUI);
      echo();
      endwin();
      exit(EXIT_FAILURE);
    }

  commun = (TableauInfoPartage*)shmat(shmid,NULL,SHM_R|SHM_W);
  if (commun == NULL)
    { 
      perror("shmat");
      sleep(4);
      curs_set(OUI);
      echo();
      endwin();
      exit(EXIT_FAILURE);
    }
  /* L'initialisation du segment de mmoire partage est termine */


  /* LE fork */
  pid = fork();
  switch(pid)
    {
    case -1: /* ca foire */
      printf("Echec cuisant du fork. Engueulez le programmeur!\n");
      sleep(4);
      curs_set(OUI);
      echo();
      endwin();
      shmctl(shmid,IPC_RMID,NULL);
      exit(1);
      break;
    case 0: /* Le fils */
      recupererTaille(nbUsers,commun,tabInfoUsers); /* Recuperer la taille */
      exit(0);
      break;
    default: /* Le pere */
      for(;;)
	{
	  tv.tv_sec = Sleeptime;
	  tv.tv_usec = (Sleeptime - (int) Sleeptime) * 1000000;
	  FD_ZERO(&in);
	  FD_SET(0, &in);
	  erase();
	  if (select(1, &in, 0, 0, &tv) > 0 && read(0, &touche, 1) == 1)
	    {
	      trier(&tabInfoUsers,nbUsers);
	      do_key(touche,&index,&couleur,nbUsers,nomUser,shmid,commun,&indicateur,&indicateur_hr,&nbre_lignes_imprimer);
	    }
	  /* Affichage infos */
	  /* Affichage fixe */
	  mvprintw(1,(COLS-strlen(titre))/2,"%s",titre);
	  bkgd(COLOR_PAIR(couleur));
	  box(stdscr,ACS_VLINE,ACS_HLINE); /* affiche un cadre autour de la fenetre */
	  afficher_legende();
	  /* Fin affichage fixe */
	  affichage(index,nbUsers,tabInfoUsers,nomUser,indicateur,indicateur_hr,nbUsers,pfichier,nbre_lignes_imprimer);
	  refresh();
	  erase();
	  if(indicateur == 1)
	    {
	      read(0,&useless,1);
	      indicateur = 0;
	      erase();
	    }
	  else if(indicateur == 4)
	    {
	      indicateur = 0;
	    }
	  actualiser_donnees(nbUsers,*commun,&tabInfoUsers);
	  sleep(0);	  	 
	}
      endwin();
      shmctl(shmid,IPC_RMID,NULL);
      shmdt((TableauInfoPartage*)commun);
    }
  return 0;
}

/* Gere l'option entree par une touche au clavier  */
void do_key(char c,int *index,int *couleur,int nbreUtilisateurs,char* nomUser,int shmid,TableauInfoPartage* commun,int *indic,int *humanRead,int *nbre_lignes_imprimer)
{
  /* Creation de variables utilisees en interne */
  char titre[]="LE FABULEUX DU + TOP";
  char lire[3];
  int nombre;

  move(2,2);
  if (c == 'q' || c == 'Q')  /* L'utilisateur veut quitter */
    { const char * chEffaceEcran="\033[H\033[J";
    putp(chEffaceEcran);
    endwin();
    shmctl(shmid,IPC_RMID,NULL);
    shmdt((TableauInfoPartage*)commun);
    exit(0);
    }
  else if (c == ' ')
    return;
  switch (c) {   /* Selon la touche entree */
  case 'u':    /* Affichage d'un utilisateur unique */
  case 'U':
    echo();
    curs_set(OUI);
    /* Affichage fixe */
    erase();
    mvprintw(1,(COLS-strlen(titre))/2,"%s",titre);
    box(stdscr,ACS_VLINE,ACS_HLINE); /* affiche un cadre autour de la fenetre */
    afficher_legende();
    /* Fin affichage fixe */
    mvprintw(8,4,"SVP, entrez les 4 premieres lettres du nom de l'utilisateur au moins.");
    mvprintw(2,3,"Quel Utilisateur(Blanc pour tous)? ");
    /* gerer la recup de la chaine du nom d'utilisateur */
    getnstr(nomUser,16);
    *indic = 1;
    noecho();
    curs_set(NON);
    break;
  case 'F':  /* Aller directement a la fin */
  case 'f':
    *index = nbreUtilisateurs - (LINES - 6);
    break;
  case 'B':  /* Page suivante */
  case 'S':
  case 's':
    if(*index <= nbreUtilisateurs - LINES - 1)
      { *index += LINES - 6; }
    else
      { *index = nbreUtilisateurs - (LINES - 6);
	printw("Plus d'utilisateurs suivants"); }
    break;
/*   case 'L': */
/*   case 'l':   /\* Ligne suivante *\/ */
/*     if(*index <= nbreUtilisateurs - LINES + 5 ) */
/*       { *index = *index + 1; } */
/*     else */
/*       { *index = nbreUtilisateurs - (LINES - 6); */
/* 	printw("Plus d'utilisateurs suivants"); } */
/*     break; */
  case 'D':   /* Retourner au debut */
  case 'd':
    *index = 0;
    break;
  case 'A':   /* Page precedente */
  case 'P':
  case 'p':
    if(*index >= LINES - 6)
      { *index -= LINES - 6; }
    else
      {
	if(*index == 0)
	  { printw("Plus d'utilisateurs precedents"); }
	else
	  { *index = 0; }
      }
    break;
/*   case 'K': */
/*   case 'k':   /\* Ligne prcdente *\/ */
/*     if(*index >= 2) */
/*       { *index -= 1; } */
/*     else */
/*       { */
/* 	if(*index == 0) */
/* 	  { printw("Plus d'utilisateurs precedents"); } */
/* 	else */
/* 	  { *index = 0; } */
/*       } */
/*     break; */
  case 'a':    /* Afficher l'aide */
    afficher_aide();
    break;
  case 'H':
  case 'h':    /* Tailles affiches en o, Ko, Mo, Go */
    if(*humanRead == 0)
      {
	*humanRead = 1;
      }
    else
      {
	*humanRead = 0;
      }
    break;
  case 'N':
  case 'n':    /* Mode de base: tri par uid */
    *indic = 0;
    break;
  case 'r':   /*Trier les utilisateurs par taille decroissante*/
  case 'R':
    printw("Tri des utilisateurs par taille decroissante : ");
    /* gerer le tri des utilisateurs */
    *indic = 3;
    break;
  case 'T':    /* Trier les utilisateurs par nom d'utilisateur */
  case 't':
    printw("Tri des utilisateurs par ordre alphabetique : ");
    /* gerer le tri des utilisateurs */
    *indic = 2;
    break;
  case 'I':
  case 'i':
    *indic = 4;
    echo();
    curs_set(OUI);
    /* Affichage fixe */
    erase();
    mvprintw(1,(COLS-strlen(titre))/2,"%s",titre);
    box(stdscr,ACS_VLINE,ACS_HLINE); /* affiche un cadre autour de la fenetre */
    afficher_legende();
    /* Fin affichage fixe */
    mvprintw(2,3,"Nombre d'utilisateurs a imprimer (entre 1 et %d): ",nbreUtilisateurs-1);
    getnstr(lire,3);
    nombre = atoi(lire);
    if(nombre < 1 || nombre > nbreUtilisateurs-1)
      {	*nbre_lignes_imprimer = nbreUtilisateurs; }
    else
      { *nbre_lignes_imprimer = nombre; }
    noecho();
    curs_set(NON);
    break;
    /* Maintenant gestion des couleurs */
  case '1':
    *couleur = 1;
    break;
  case '2':
    *couleur = 2;
    break;
  case '3':
    *couleur = 3;
    break;
  case '4':
    *couleur = 4;
    break;
    /*  case '\7F':
    *index = 0;
    break;*/
  default:
    printw("Commande `%c' inconnue!", c);
  }
}

void affichage(int index,int noUser,TableauInformationsUtilisateurs tabInfoUsers,char* nomUtilisateur,int indic,int humanRead, int nbUsers,FILE *pfile,int nbre_lignes_imprimer)
{
  int ancre = 4;
  int indice,test;
  int recherche=0;
  char legende0[] = "N";
  char legende1[] = "NOM";
  char legende2[] = "UID";
  char legende3[] = "REPERTOIRE";
  char legende4[] = "TAILLE";
  /* deplacement du curseur d'impression */
  move(ancre,2);

  /* un big switch case pour gerer les differents cas d'affichage */
  switch(indic)
    {
    case 1:    /* Un seul utilisateur a afficher */
      /* rcuperer l'UID du nom correspondant */
      test = 0;
      for(indice=1;indice<181;indice++)
	{
	  if(strncmp(tabInfoUsers[indice].nom,nomUtilisateur,4) == 0)
	    {
	      if(humanRead == 0)
		{
	      printw("%4d %12s %5d %30s %10d",1,tabInfoUsers[indice].nom,tabInfoUsers[indice].id,tabInfoUsers[indice].repertoirePerso,tabInfoUsers[indice].taille);
		}
	      else
		{
	      printw("%4d %12s %5d %30s %10s",1,tabInfoUsers[indice].nom,tabInfoUsers[indice].id,tabInfoUsers[indice].repertoirePerso,tabInfoUsers[indice].taille_hr);
		}
	      test = 1;
	    }
	}
      if(test != 1)
	{
	  mvprintw(5,4,"L'utilisateur n'existe pas, desole.");
	}
      mvprintw(6,4,"Appuyez sur une touche pour continuer...");
      break;

    case 2:    /* Tri des utilisateurs par nom */
      for (noUser=1;noUser<LINES-5;noUser++)
	{
	  if(tabInfoUsers[noUser+index].nom != "")
	    {
	      recherche=0;
	      while (tabInfoUsers[recherche].ordreAlpha!=(noUser+index) && recherche<=nbUsers)
		{
		  recherche++;
		  if (tabInfoUsers[recherche].ordreAlpha==(noUser+index))
		    {
		      if(humanRead == 0)
			{
			  printw("%4d %12s %5d %30s %10d",noUser+index,tabInfoUsers[recherche].nom,tabInfoUsers[recherche].id,tabInfoUsers[recherche].repertoirePerso,tabInfoUsers[recherche].taille);
			}
		      else
			{
			  printw("%4d %12s %5d %30s %10s",noUser+index,tabInfoUsers[recherche].nom,tabInfoUsers[recherche].id,tabInfoUsers[recherche].repertoirePerso,tabInfoUsers[recherche].taille_hr);
			}
		      ancre += 1;
		      move(ancre,2);
		    }
		}
	    }
	  else
	    { printw(""); }
	}
      break;

      /* Tri des utilisateurs par taille de disque */
    case 3:
      for (noUser=1;noUser<LINES-5;noUser++)
	{
	  if(tabInfoUsers[noUser+index].nom != "")
	    {
	      recherche=0;
	      while ((nbUsers-tabInfoUsers[recherche].ordreTaille)!=(noUser+index) && recherche<=nbUsers)
		{
		  recherche++;
		  if ((nbUsers-tabInfoUsers[recherche].ordreTaille)==(noUser+index))
		    {
		      if(humanRead == 0)
			{
			  printw("%4d %12s %5d %30s %10d",noUser+index,tabInfoUsers[recherche].nom,tabInfoUsers[recherche].id,tabInfoUsers[recherche].repertoirePerso,tabInfoUsers[recherche].taille);
			}
		      else
			{
			  printw("%4d %12s %5d %30s %10s",noUser+index,tabInfoUsers[recherche].nom,tabInfoUsers[recherche].id,tabInfoUsers[recherche].repertoirePerso,tabInfoUsers[recherche].taille_hr);
			}
		      ancre += 1;
		      move(ancre,2);
		    }
		}
	    }
	  else
	    { printw(""); }
	}
      break;

      /* Impression dans un fichier */
    case 4:
      pfile = fopen("resultats_dutop","w");
      if (pfile == (FILE *)0)
	{
	  printw("Erreur d'ouverture de fichier, ne peut imprimer!");
        }
      fprintf(pfile,"\n***************************** RESULTATS DU DUTOP *********************\n\n");
      fprintf(pfile,"Tous droits reserves aux auteurs:\n");
      fprintf(pfile,"\tFALLET Laurent\n\tFOUILLEUX Samy\n\tMORRETTON Laurent\nRealise en ASI (INSA de Rouen) en janvier 2003\n\nDebut du listing:\n\n");
      fprintf(pfile,"%4s %12s %5s %30s %10s\n",legende0,legende1,legende2,legende3,legende4);
      for (noUser=1;noUser<nbre_lignes_imprimer + 1;noUser++)
	{
	  if(tabInfoUsers[noUser].nom != "")
	    {
	      recherche=0;
	      while ((nbUsers-tabInfoUsers[recherche].ordreTaille)!=(noUser) && recherche<=nbUsers)
		{
		  recherche++;
		  if ((nbUsers-tabInfoUsers[recherche].ordreTaille)==(noUser))
		    {
		      if(humanRead == 0)
			{
			  fprintf(pfile,"%4d %12s %5d %30s %10d\n",noUser,tabInfoUsers[recherche].nom,tabInfoUsers[recherche].id,tabInfoUsers[recherche].repertoirePerso,tabInfoUsers[recherche].taille);
			}
		      else
			{
			  fprintf(pfile,"%4d %12s %5d %30s %10s\n",noUser,tabInfoUsers[recherche].nom,tabInfoUsers[recherche].id,tabInfoUsers[recherche].repertoirePerso,tabInfoUsers[recherche].taille_hr);
			}
		    }
		}
	    }
	  else
	    { fprintf(pfile,"\n"); }
	}
      fprintf(pfile,"\n\t---------------- Fin du listing de Dutop ---------------\n");
      fprintf(pfile,"\n Si vous desirez connaitre les auteurs ou avoir des informations,\n vous pouvez contacter:\n\tlaurent.fallet@insa-rouen.fr\n\tsamy.fouilleux@insa-rouen.fr\n\tlaurent.morretton@insa-rouen.fr\n");
      fprintf(pfile,"____________________________________________________________________\n");
      if ((fclose(pfile)) == EOF)
	{
        printw("Erreur de fermeture du fichier.");
        }
      else
	{
	  system("emacs resultats_dutop&");
	}
      break;
      /* Fin de l'impression dans le fichier */

      /* Cas general (normal, option n) */
    default:
      for (noUser=1;noUser<LINES-5;noUser++)
	{
	  if(tabInfoUsers[noUser+index].nom != "")
	    {
	      if(humanRead == 0)
		{
		  mvprintw(ancre,2,"%4d %12s %5d %30s %10d",noUser+index,tabInfoUsers[noUser+index].nom,tabInfoUsers[noUser+index].id,tabInfoUsers[noUser+index].repertoirePerso,tabInfoUsers[noUser+index].taille);
		}
	      else
		{
		  mvprintw(ancre,2,"%4d %12s %5d %30s %10s",noUser+index,tabInfoUsers[noUser+index].nom,tabInfoUsers[noUser+index].id,tabInfoUsers[noUser+index].repertoirePerso,tabInfoUsers[noUser+index].taille_hr);
		}
	      ancre += 1;
	    }
	  else
	    { printw(""); }
	}
    }
}

/* legende qui apparait au dessus des colonnes de donnees */
void afficher_legende(void)
{
  char legende0[] = "N";
  char legende1[] = "NOM";
  char legende2[] = "UID";
  char legende3[] = "REPERTOIRE";
  char legende4[] = "TAILLE";
  mvprintw(3,2,"%4s %12s %5s %30s %10s",legende0,legende1,legende2,legende3,legende4);
}

/* Affichage de l'aide */
void afficher_aide(void)
{
  int touche_clavier;
  do
    {
      /* Re affichage du cadre, du titre */
      mvprintw(3,2,"\tAIDE de DU + TOP\n");
      box(stdscr,ACS_VLINE,ACS_HLINE); /* affiche un cadre autour de la fenetre */
      mvprintw(4,3,"'a'  permet d'obtenir cette aide");
      mvprintw(5,3,"'h' ou 'H' active ou  desactive l'affichage de la taille en Ko, Mo ou Go");
      mvprintw(6,3,"'t' ou 'T' pour trier les utilisateurs par taille");
      mvprintw(7,3,"       `-> permet egalement de rafraichir les informations");
      mvprintw(8,3,"'r' ou 'R' pour trier les utilisateurs par nom (ordre lexicographique)");
      mvprintw(9,3,"'u' ou 'U' pour choisir un utilisateur en particulier");
      mvprintw(10,3,"'n' ou 'N' pour revenir a l'affichage de base (tri par uid)");
      mvprintw(11,3,"'p' ou 'P' permet d'obtenir la page precedente");
      mvprintw(12,3,"'s' ou 'S' permet d'obtenir la page suivante");
      mvprintw(13,3,"'k' ou 'K' permet d'obtenir la ligne precedente");
      mvprintw(14,3,"'l' ou 'L' permet d'obtenir la ligne suivante");
      mvprintw(15,3,"'d' ou 'D' permet d'aller au debut de la liste");
      mvprintw(16,3,"'f' ou 'F' permet d'aller a la fin de la liste");
      mvprintw(17,3,"'i' ou 'I' permet d'imprimer les resultats dans un fichier (resultat)");
      mvprintw(LINES-2,3,"Appuyez sur Echap pour quitter!");
      touche_clavier = getch();
    }
  while(touche_clavier!=ESCAPE);
}

/* Recuperer la liste des utilisateurs */
void recupererUtilisateurs(int *nombreUtilisateurs,TableauInformationsUtilisateurs *TiU)
{
  int i;
  uid_t id;
  struct passwd ChampsUtilisateur;
  *nombreUtilisateurs=2;

  for (i=UID_DEPART;i<=3000;i++)  /* Les premiers utilisateurs ont un UID qui commence a 501 */
    {
      id=i;
      if (getpwuid(id)!=NULL)
	{
	  ChampsUtilisateur = *getpwuid(id);
	  (*TiU)[*nombreUtilisateurs].ordreAlpha=(*nombreUtilisateurs);
	  (*TiU)[*nombreUtilisateurs].ordreTaille=(*nombreUtilisateurs);
	  (*TiU)[*nombreUtilisateurs].taille=0;
	  strcpy((*TiU)[*nombreUtilisateurs].taille_hr,"NC");
	  (*TiU)[*nombreUtilisateurs].id=id;
	  (*TiU)[*nombreUtilisateurs].nom=(char *)malloc(strlen(ChampsUtilisateur.pw_name)*sizeof(char)+1);
	  (*TiU)[*nombreUtilisateurs].repertoirePerso=(char *)malloc(strlen(ChampsUtilisateur.pw_dir)*sizeof(char)+1);
	  strcpy((*TiU)[*nombreUtilisateurs].nom,ChampsUtilisateur.pw_name);
	  strcpy((*TiU)[*nombreUtilisateurs].repertoirePerso,ChampsUtilisateur.pw_dir);
	  (*nombreUtilisateurs)++;
	}
    }

  /* Pour le root */
  ChampsUtilisateur = *getpwuid(0);
  (*TiU)[1].id=0;
  (*TiU)[1].ordreAlpha=1;
  (*TiU)[1].ordreTaille=1;
  strcpy((*TiU)[1].taille_hr,"NC");
  (*TiU)[1].nom=(char *)malloc(strlen(ChampsUtilisateur.pw_name)*sizeof(char)+1);
  (*TiU)[1].repertoirePerso=(char *)malloc(strlen(ChampsUtilisateur.pw_dir)*sizeof(char)+1);
  strcpy((*TiU)[1].nom,ChampsUtilisateur.pw_name);
  strcpy((*TiU)[1].repertoirePerso,ChampsUtilisateur.pw_dir);
}

/* Recuperation des tailles occupees par les utilisateurs par le processus fils */ 
void recupererTaille(int nombreUtilisateurs,TableauInfoPartage* commun,TableauInformationsUtilisateurs TiU)
{
  int indice;
  for(indice=1;indice<nombreUtilisateurs;indice++)
    {
      if(indice!=67 && indice!=147 && indice!=113)
	{
	  (*commun)[indice].taille = taille(TiU[indice].repertoirePerso);
	}
    }
}

/* Procedure de transfert du segment de memoire partage vers la structure du pere */
void actualiser_donnees(int nombreUtilisateurs,TableauInfoPartage commun,TableauInformationsUtilisateurs *TiU)
{
  int indice;
  float tailleTemp;
  for(indice=1;indice<nombreUtilisateurs;indice++)
    {
      tailleTemp = commun[indice].taille*1.0 ; /* On rcupere la taille du segment de mem partagee */
      (*TiU)[indice].taille = commun[indice].taille;
      
      /* On fait la traduction en human readable en meme temps */
      if (tailleTemp==1.0)
	{
	  strcpy((*TiU)[indice].taille_hr,"<1 Ko");
	}
      else if (tailleTemp==0.0)
	{
	  strcpy((*TiU)[indice].taille_hr,"nc");
	}
      else
	{
	  if (tailleTemp<=1024)
	    {
	      sprintf((*TiU)[indice].taille_hr,"%.1f Ko",tailleTemp);
	    }
	  else
	    {
	      tailleTemp=tailleTemp/1024.0;
	      if (tailleTemp<=1024)
		{
		  sprintf((*TiU)[indice].taille_hr,"%.1f Mo",tailleTemp);
		}
	      else
		{
		  tailleTemp=tailleTemp/1024;
		  sprintf((*TiU)[indice].taille_hr,"%.1f Go",tailleTemp);
		}
	    }
	}
    }
}

/* Procedure de tri */
void trier(TableauInformationsUtilisateurs *TiU, int nbMaxUsers)
{
  /* Par utilisateur, classement alphabtique */
  char dernierNom[20];
  char nomEnCours[20];
  int i,j;
  int rang;

  int tailleEnCours;
  int derniereTaille;
  int doublons;

  strcpy(dernierNom,"aaaaa");
  for (i=1;i<nbMaxUsers;i++)
    {
      rang=1;
      strcpy(nomEnCours,"zzzz");
      for (j=1;j<nbMaxUsers;j++)
	{
	  if (strcmp(dernierNom,(*TiU)[j].nom)<0)
	    {
	      if (strcmp(nomEnCours,(*TiU)[j].nom)>=0)
		{
		  strcpy(nomEnCours,(*TiU)[j].nom);
		  rang=j;
		}
	    }
	}
      strcpy(dernierNom,nomEnCours);
      (*TiU)[rang].ordreAlpha=i;
    }

  /* Par taille*/
  
  derniereTaille=-1;
  for (i=1;i<nbMaxUsers;i++)
    {
      rang=1;
      tailleEnCours=100000000;
      for (j=1;j<nbMaxUsers;j++)
	{
	  if ((*TiU)[j].taille>derniereTaille)
	    {
	      if ((*TiU)[j].taille==tailleEnCours)
		{
		  doublons++;
		}
	      if ((*TiU)[j].taille<tailleEnCours)
		{
		  tailleEnCours=(*TiU)[j].taille;
		  rang=j;
		  doublons=0;
		}
	    }
	}
      if (doublons!=0)
	{
	  for (j=1;j<nbMaxUsers;j++)
	    {
	      if (tailleEnCours==(*TiU)[j].taille)
		{
		  (*TiU)[j].ordreTaille=i;
		  i++;
		}
	    }
	  i--;
	}
      else
	{
	  (*TiU)[rang].ordreTaille=i;
	}
      derniereTaille=tailleEnCours;
    }
}
/* Fin de DU+TOP */

